/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-07-31 20:31
**/

#include<bits/stdc++.h>
using namespace std;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef long double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;

const int MAXN = 2e5 + 5;
ll N;

vector<vector<int>> edges;
vector<bool> used;
vector<ll> total_kids;


ll dfs_tree(int node){
    ll res = 0;
    used[node] = true;
    for(auto v: edges[node])
        if(not used[v])
            res += dfs_tree(v);
    if(res == 0) res = 1;
    total_kids[node] = res;
    return res;
}

void solve(){
    // Code goes here ...
    cin >> N;

    edges = vector<vector<int>>(N + 1);
    used = vector<bool>(N + 1);
    total_kids = vector<ll>(N + 1);

    ll u, v;
    R(i, N-1){
        cin >> u >> v;
        edges[u].emplace_back(v);
        edges[v].emplace_back(u);
    }
    total_kids[1] = dfs_tree(1);

    ll Q, res;
    cin >> Q;
    R(i, Q){
        cin >> u >> v;
        res = total_kids[u] * total_kids[v];
        cout << res << endl;
    }
}

int main(){
    cout << fixed << setprecision(8);
    int T;
    cin >> T;
    while(T--)
        solve();
}
        
